import os
import config
import pygsheets
from db_connet import *
from datetime import datetime, timedelta, timezone


# 載入參數
GS_CONFIG = config.GS_CONFIG
RED = config.RED
__directory__ = os.path.dirname(os.path.abspath(__file__))
__LogFileName__ = datetime.today().strftime("%Y%m%d")+'.txt'

def now():
    tz = timezone(timedelta(hours=+8))
    return datetime.now(tz).strftime("%Y-%m-%d %H:%M:%S")

def logTxt(msg):
    filename = f"{__directory__+'/logs/'+__LogFileName__}"
    f = open(filename, "a")
    f.write("{0} -- {1}\n".format(now(), msg))
    f.close()   

web = ['june1','baby']
logTxt('===== Start ======')
for args in web:
    logTxt('web:'+args)
    dictionary = {}
    log_data = select_db("select sub_tab.*, concat('update log_track_revenue_order set origin_total = ', sub_tab.new_total, ' where id = ', sub_tab.id) upd_query from ( select l.id, l.today, l.origin_total, ( select sum(totalprice_after - web_discount - class_discount - member_discount - coupon_discount - entity_discount) total from order_list where find_in_set(ordernumber, l.ordernumbers) > 0 ) new_total from log_track_revenue_order l where l.today >= date_sub(current_date(), interval 60 day) ) sub_tab where sub_tab.origin_total != sub_tab.new_total",args)
    logTxt(f"select sub_tab.*, concat('update log_track_revenue_order set origin_total = ', sub_tab.new_total, ' where id = ', sub_tab.id) upd_query from ( select l.id, l.today, l.origin_total, ( select sum(totalprice_after - web_discount - class_discount - member_discount - coupon_discount - entity_discount) total from order_list where find_in_set(ordernumber, l.ordernumbers) > 0 ) new_total from log_track_revenue_order l where l.today >= date_sub(current_date(), interval 60 day) ) sub_tab where sub_tab.origin_total != sub_tab.new_total")
    for i in log_data:
        update_db(f"update log_track_revenue_order set origin_total = '{str(i['new_total'])}' , updated_at = '{now()}' where id = '{str(i['id'])}'",args)
        logTxt(f"update log_track_revenue_order set origin_total = '{str(i['new_total'])}' , updated_at = '{now()}' where id = '{str(i['id'])}'")
        dictionary[datetime.strftime(i['today'],'%Y/%-m/%-d')] = i['new_total']

    logTxt('跑完update log_track_revenue_order')
    days, new_total= list(dictionary.keys()),list(dictionary.values())
    str_days = ','.join(days)
    logTxt("block date ["+str_days+"]")
    gc = pygsheets.authorize(service_file = GS_CONFIG['json_key'])
    logTxt('read google key')
    sht = gc.open_by_url(GS_CONFIG['url'])
    logTxt('read google url')
    gd = sht.worksheet_by_title(GS_CONFIG['worksheet'])
    logTxt('read google sheet')
    title = gd.get_values(GS_CONFIG[args]['g_sheet_title_start'],GS_CONFIG[args]['g_sheet_title_end'])[0][0]
    # 過濾空白字串
    title = title.rstrip()
    logTxt('read title')
    try:
        logTxt('into 判斷title')
        logTxt('my title ->'+title)
        if(title == '訂單金額'):
            logTxt('訂單金額字串判斷成功')
            for k,day in enumerate(days):
                logTxt('跑for了喔')
                logTxt('day['+day+']')
                path = gd.find(f'{day}')
                logTxt('取得金額座標')
                # 取得訂單金額座標
                price_path = GS_CONFIG[args]['g_sheet_title']+path[0].label[1:10] 
                logTxt('金額座標:'+price_path)
                # 寫入log (統一寫入官網db)
                logTxt(f"INSERT INTO `log_track_transaction_order_from_py`(`id`, `platform`,`day`,`path`, `origin_data`, `new_data`, `created_at`, `updated_at`) VALUES (NULL,'{args}','{day.replace('/', '-')}','{price_path}','{gd.cell(price_path).value}',NULL,'{now()}',NULL)")
                insert_id = insert_db(f"INSERT INTO `log_track_transaction_order_from_py`(`id`, `platform`,`day`,`path`, `origin_data`, `new_data`, `created_at`, `updated_at`) VALUES (NULL,'{args}','{day.replace('/', '-')}','{price_path}','{gd.cell(price_path).value}',NULL,'{now()}',NULL)",'june1')

                # 更新google sheet
                gd.cell(price_path).value = int(new_total[k])
                
                # 更新log
                update_db(f"UPDATE `log_track_transaction_order_from_py` SET `new_data`= '{new_total[k]}',`updated_at`= '{now()}' WHERE id = '{insert_id}'",'june1') # 寫入log
    except:
        pass
logTxt('===== End ======')
    